#include "videomgr.h"
#include "io.h"

void videomgr::Center(int xadd, int y, int c,int tr,int time, const char *Buf)
{
	int nx, x;
	
	const char *s = Buf;
GetNx:
	for(x=0; s[x] && s[x]!='\n'; x++);
	x = nx = xadd + (41-xadd-x) / 2;
	
	for(; *s; s++)
		switch(*s)
		{
			case '\b':
				x--;
				break;
			case '\n':
				y++;
				s++;
				goto GetNx;
				break;
			case '\r':
				x=nx;
				break;
			default:
				SetChar(x++,y,*s, c,tr,time);
		}
}
videomgr::videomgr()
{
	InstallDriver(&vt100, 0);
	SelectDriver(DEFAULT_IO);
	InitVideo();	
}
videomgr::~videomgr()
{
	close();
}
void videomgr::close()
{
	DoneVideo();
}
void videomgr::draw()
{
   	for(unsigned y=0; y<24; ++y)
   		for(unsigned x=0; x<40; ++x)
   		{
   			unsigned c=0;
   			if(!y || y==23)
   			{
   				if(x > 0)c |= c_lt;
   				if(x < 39)c |= c_rt;
   			}
   			if(!x || x==39)
   			{
   				if(y > 0)c |= c_up;
   				if(y < 23)c |= c_dn;
   			}
   			SetChar(x,y, corner(c),
   				c ? 0x3F : 0x11,
   			    0,0);
   		}
}

void videomgr::popups()
{
   	Center(5, 4, 0x0A, 0, 100,
   		"Multiple base calculator\n"
   		"and value converter\n"
   		VERSION);
   		
   	Center(5, 17, 0x08, 0, 70, 
   		"Copyright (C) 1992,2000\n"
   		"Bisqwit");
   	Center(5, 19, 0x08, 0, 500,
   		"http://iki.fi/bisqwit/");

   	// This is the help text.
   	// It will leave after many seconds.
   	Center(5, 14, 0x07, 0, 300,
   	    "** HELP **\n"
   		"Enter a numeric expression,\n"
   		"and you see its value.");
   	
   	// This will mask the help text away
   	// for the first some seconds.
   	Center(5, 14, 0x0C, 0, 68,
   	    "          \n"
   		"                           \n"
   		"                      ");
   		
   	Center(0,21, 0x3F, 0,0,
   		"- Result: ----------------------------");
   	
   	Center(0,20, 0x18, 0,1200,
   		"NES-style output module. Yeah. :)");
   	Center(0,20, 0x17, 0,200,
   		"                                 ");
   	
   	Center(0,1, 0x19, 0,0,   "---- GPL. See the file COPYING. ----");
   	Center(0,1, 0x17, 0,140, "                                    ");
}
